console.log('Integração Ribeiro Digisac');

async function getAsyncElement(selector, timeout = 10000) {
    let elem = undefined;

    return new Promise((resolve, reject) => {
        if (!selector) return reject(`Error: Selector not defined`)

        const interval = setInterval(() => {
            elem = document.querySelector(selector);
            if (elem) {
                clearInterval(interval);
                resolve(elem)
            }
        }, 1);

        setTimeout(() => {
            clearInterval(interval);
            reject(`Error: Search time exceeded, ${selector} element not found.`)
        }, timeout);
    });
}

(async () => {
    const tabNewContacts = await getAsyncElement("[data-testid='chat-tab-start_conversation']");
    
    const url = new URL(window.location.href);
    const newchat = url.searchParams.get('newchat');
    
    if(newchat) {
        await tabNewContacts.click();

        const contact = await getAsyncElement("#app div:nth-child(2) > div > div.p-0.border-right.col-md-3 > div > div.flex-fill.bg-white.chat-contact-list > div:nth-child(1) > div > div > div:nth-child(1)");
        contact.click();
    }
})();