console.log('Integração Ribeiro Vistasoft');

const serviceId = 'f67f5125-e508-4efe-bc51-191cb8f24825';
const apiBaseUrl = 'https://ribeiroimoveis.digisac.biz/api/v1/';

const modal = `
  <div class="itg-modal-container" style="
      position: fixed;
      z-index: 10000;
      top: 0;
      left: 0;
      bottom: 0;
      right: 0;
      background-color: #00000099;
      overflow: hidden;
      display: flex;
      justify-content: center;
      align-content: center;
      align-items: center;
  ">
      <div class="itg-modal-wrap" style="
      width: clamp(190px, 100%, 300px);
      min-height: 100px;
      background-color: #ffffff;
      padding: 18px;
      display: flex;
      align-items: center;
      justify-content: center;
      border-radius: 12px;
      font-size: 2rem;
  ">
          <p>Iniciando conversa</p>
      </div>
  </div>
`;

document.addEventListener('click', async function (event) {
  if (event.target.tagName.toLowerCase() === 'a' && event.target.href.indexOf("https://api.whatsapp.com/") === 0) {
    event.target.removeAttribute('target');
    event.target.setAttribute('style', 'pointer-events:none;');

    document.body.innerHTML += modal;

    const url = new URL(event.target.href);

    event.target.href = '#';

    const phone = url.searchParams.get('phone');
    const text = url.searchParams.get('text');

    const api_url = `${apiBaseUrl}contacts?where[visible]=true&where[data.number][%24iLike]=%${phone}%&page=1&perPage=1`

    try {
      const response = await fetch(api_url, {
        method: "GET",
        headers: {
          "Content-Type": "application/json",
          "Authorization": "Bearer ffe78843c6fe75d8514ae99cb6b488d2c7258d72"
        },
      });

      const res = await response.json();

      let contactId = res?.data[0]?.id || null;

      if (res?.total == 0) {
        const clienteName = document.querySelector("#contato-resumo-cliente div.borda-box-dados-cliente div.dados-cliente-principais .nome-cliente").textContent;
        contactId = await addContact(clienteName, phone);
      }

      if (contactId) {
        const bodyMsg = {
          text: text,
          number: phone,
          contactId: contactId,
          serviceId: serviceId,
        }

        await sendMessage(bodyMsg)
      }
      removeModal();
    } catch (error) {
      removeModal();
      alert('Não foi possível iniciar uma conversa no Digisac');
    }
  }
});

async function addContact(internalName, number) {

  const errorMsg = 'Não foi possível cadastrar o cliente no Digisac';

  if (!internalName || !number) {
    removeModal();
    alert(errorMsg);
    return false;
  }

  const api_url = `${apiBaseUrl}contacts`;

  const body = {
    internalName: internalName,
    number: number,
    serviceId: serviceId,
    tagId: []
  }

  try {
    const response = await fetch(api_url, {
      method: "POST",
      headers: {
        "Content-Type": "application/json",
        "Authorization": "Bearer ffe78843c6fe75d8514ae99cb6b488d2c7258d72"
      },
      body: JSON.stringify(body),
    });

    const result = await response.json();

    const clienteId = result?.id;

    if (!clienteId) {
      removeModal();
      alert(errorMsg);
      return false;
    }

    removeModal();
    return clienteId;
  } catch (error) {
    removeModal();
    alert(errorMsg);
    return false;
  }
}


async function sendMessage(bodyMsg) {

  const errorMsg = 'Não foi possível iniciar uma conversa no Digisac';

  const api_url = `${apiBaseUrl}messages`

  try {
    const response = await fetch(api_url, {
      method: "POST",
      headers: {
        "Content-Type": "application/json",
        "Authorization": "Bearer ffe78843c6fe75d8514ae99cb6b488d2c7258d72"
      },
      body: JSON.stringify(bodyMsg),
    });

    const result = await response.json();

    if (!result?.sent) {
      removeModal();
      return alert(errorMsg);
    }
    removeModal();
    window.open('https://ribeiroimoveis.digisac.biz/?newchat=new', '_blank');

  } catch (error) {
    removeModal();
    alert(errorMsg);
  }
}

function removeModal() {
  document.querySelector('.itg-modal-container')?.remove();
}