
console.log("Integração Ribeiro Superlogica")

let css_seletor = "#conteudo > div:nth-child(7) > div:nth-child(2) > div:nth-child(1) > section > center:nth-child(5) > a";

if(window.location.pathname === "/imobiliaria/proprietarios/index") {
    css_seletor = "#barraDeFerramentas > div.btn-group > a.btn.btn-success";
}

const btnNovoProprietario = document.querySelector(css_seletor);
const btnAlterarProprietario = document.querySelector("#conteudo > div:nth-child(7) > div.col-md-6.pull-left > div > div.panel-body > a");

const inputsNames = [
    'ST_CNPJ_PES',
    'ST_NOME_PES',
    'ST_TELEFONE_PES',
    'ST_EMAIL_PES',
    'ST_RG_PES',
    'ST_ORGAO_PES',
    'DT_NASCIMENTO_PES',
    'ST_ESTADOCIVIL_PES',
    'ST_NACIONALIDADE_PES',
    'ST_CEP_PES', 
    'ST_ENDERECO_PES',
    'ST_NUMERO_PES',
    'ST_BAIRRO_PES',
    'ST_CIDADE_PES',
    'ST_ESTADO_PES'
]; 

const estadoCivil = [
    'Casado(a)',
    'Solteiro(a)',
    'Viúvo(a)',
    'Divorciado(a)',
    'Divorciado(a)',
    'Divorciado(a)',
    'Casado(a)',
];

const url = 'https://integracoes.ribeiroimoveis.com.br/wh-vistasoft.php';

function cadastrarProprietario() {
    btnNovoProprietario.addEventListener('click', async () => {

        await getAsyncElement("#myModal"); // Espera o modal de cadastro aparecer
    
        const salvar = await getAsyncElement('#salvar.btn-form.btn.btn-primary.assistente_passo');
    
        salvar.addEventListener('click', async (e) => {

            const form = e.target.form;
    
            const field = {};
    
            inputsNames.map(name => {
                const value = form.querySelector(`[name="${name}"]`).value
                Object.defineProperties(field, {
                    [name]: {
                        value: value,
                        writable: true
                    }
                })
            })

            const body = {
                "fields": {
                    "CPFCNPJ": field.ST_CNPJ_PES,
                    "RG": field.ST_RG_PES,
                    "RGEmissor": field.ST_ORGAO_PES,
                    "DataNascimento": field.DT_NASCIMENTO_PES.split('/').reverse().join('-'),
                    "Nacionalidade": field.ST_NACIONALIDADE_PES,
                    "EstadoCivil": estadoCivil[Number(field.ST_ESTADOCIVIL_PES) - 1 || 0],
                    "FonePrincipal": field.ST_TELEFONE_PES,
                    "EnderecoResidencial": field.ST_ENDERECO_PES,
                    "BairroResidencial": field.ST_BAIRRO_PES,
                    "CidadeResidencial": field.ST_CIDADE_PES,
                    "UFResidencial": field.ST_ESTADO_PES,
                    "CEPResidencial": field.ST_CEP_PES,
                    "Nome": field.ST_NOME_PES,
                    "EnderecoNumero": field.ST_NUMERO_PES,
                    "EmailResidencial": field.ST_EMAIL_PES,
                    "VeiculoCaptacao": "Desconhecido",
                    "Interesse":"Locação"
                }
            }

            const xhr = new XMLHttpRequest();

            xhr.open("POST", url, true);
            xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");

            const toastSuccess = await getAsyncElement("#toast-container.toast-bottom-right .toast.toast-success");
    
            if(toastSuccess) {
                xhr.send(`cadastro=${JSON.stringify(body)}`);  
            }    
        })
    });
}

function alterarProprietario() {
    btnAlterarProprietario.addEventListener('click', async () => {
        
        await getAsyncElement("#myModal"); // Espera o modal aparecer
    
        const salvar = await getAsyncElement('#myModal #Forms_ProprietariosBeneficiarios_Post input[name="salvar"]');

        salvar.addEventListener('click', async (e) => {
            const form = await getAsyncElement('#myModal #Forms_ProprietariosBeneficiarios_Post');
    
            const field = {};
    
            inputsNames.map(name => {
                const value = form.querySelector(`#myModal #Forms_ProprietariosBeneficiarios_Post [name="${name}"]`).value
                Object.defineProperties(field, {
                    [name]: {
                        value: value,
                        writable: true
                    }
                })
            });

            const body = {
                "fields": {
                    "CPFCNPJ": field.ST_CNPJ_PES,
                    "RG": field.ST_RG_PES,
                    "RGEmissor": field.ST_ORGAO_PES,
                    "DataNascimento": field.DT_NASCIMENTO_PES.split('/').reverse().join('-'),
                    "Nacionalidade": field.ST_NACIONALIDADE_PES,
                    "EstadoCivil": estadoCivil[Number(field.ST_ESTADOCIVIL_PES) - 1 || 0],
                    "FonePrincipal": field.ST_TELEFONE_PES,
                    "EnderecoResidencial": field.ST_ENDERECO_PES,
                    "BairroResidencial": field.ST_BAIRRO_PES,
                    "CidadeResidencial": field.ST_CIDADE_PES,
                    "UFResidencial": field.ST_ESTADO_PES,
                    "CEPResidencial": field.ST_CEP_PES,
                    "Nome": field.ST_NOME_PES,
                    "EmailResidencial": field.ST_EMAIL_PES,
                    "EnderecoNumero": field.ST_NUMERO_PES
                }
            }

            const xhr = new XMLHttpRequest();

            xhr.open("POST", url, true);
            xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");

            const toastSuccess = await getAsyncElement("#toast-container.toast-bottom-right .toast.toast-success");
    
            if(toastSuccess) {
                xhr.send(`cliente=${window.idPessoa}&cadastro=${JSON.stringify(body)}`);  
            }    
        })
    })
}

if(btnNovoProprietario) {
    cadastrarProprietario();
} else if(btnAlterarProprietario) {
    alterarProprietario();
}

async function getAsyncElement(selector, timeout = 10000) {
    let elem = undefined;

    return new Promise((resolve, reject) => {
        if (!selector) return reject(`Error: Selector not defined`)

        const interval = setInterval(() => {
            elem = document.querySelector(selector);
            if (elem) {
                clearInterval(interval);
                resolve(elem)
            }
        }, 1);

        setTimeout(() => {
            clearInterval(interval);
            reject(`Error: Search time exceeded, ${selector} element not found.`)
        }, timeout);
    });
}